using System;

using System.IO;

using System.Collections;

using System.Runtime;

using System.Xml;

using System.Xml.Xsl;

using System.Diagnostics;

using System.Text;

using NUnit.Framework;



namespace VSNUnit2k3

{
/*
	#region UnitTests



	[TestFixture]

	public class CTestNUnitWrapper

	{

		private CNUnitWrapper cnu;

		private const string gooddll = @"C:\temp\temptest\bin\debug\temptest.exe";

		private const string baddll = @"C:\temp\nosuchdirectory\none.dll";

		private const string baddll2 = "C:/temp/nosuchdirectory/none.dll";

		private const string nonunitdll = @"c:\temp\temptestnonunit\bin\debug\temptestnonunit.exe";

		private const string goodnunit = @"c:\Program Files\NUnit V2.1\bin\nunit-console.exe";

		private const string savefile = @"c:\temp\temptest\newresults.xml";

		private const string readfile = @"c:\temp\TestResult.xml";

		



		[SetUp]

		public void Setup()

		{

			cnu = new CNUnitWrapper();

			cnu.NUnitExec = goodnunit;

			System.IO.File.Delete(savefile);

		}



		[TearDown]

		public void TearDown()

		{

			cnu = null;

		}



		[Test]

		public void TestTest()

		{

			XmlDocument res = cnu.Test(gooddll);

			Assert.IsNotNull(res);

			Assert.IsTrue(res.SelectNodes("//message").Count > 0);

			Assert.Fail("hey!");



		}



		[Test]

		public void TestBadDll()

		{

			XmlDocument res = cnu.Test(baddll2);

			Assert.IsNull(res);

		}



		[Test]

		public void TestNoNunit()

		{

			XmlDocument res = cnu.Test(nonunitdll);

			Assert.IsNotNull(res);

			Assert.IsTrue(res.SelectNodes("//message").Count == 0);

		}



		[Test]

		public void TestSaveResults()

		{

			Assert.IsFalse(System.IO.File.Exists(savefile));

			cnu.Test(baddll);

			cnu.SaveResults(savefile);

			Assert.IsFalse(System.IO.File.Exists(savefile), "Bad dll produced saved results");

			cnu.Test(gooddll);

			cnu.SaveResults(savefile);

			Assert.IsTrue(System.IO.File.Exists(savefile), "Good dll failed to produce saved results");

			System.IO.FileStream fs = System.IO.File.OpenRead(savefile);

			Assert.IsTrue(fs.Length > 0, "Good dll produced empty results");

			fs.Close();

			

		}



		[Test]

		public void TestReadResults()

		{

			Assert.IsTrue(System.IO.File.Exists(readfile), "The readfile does not exist.");

			StreamReader sr = new StreamReader(readfile);

			XmlDocument xd = cnu.ReadInput(sr);

			Assert.IsNotNull(xd, "xml document is null");

			Assert.IsTrue(xd.ChildNodes.Count > 0);

			sr.Close();

		}



	}



	#endregion
*/


	/// <summary>

	/// Wrapper file for controlling NUnit.

	/// </summary>

	public class CNUnitWrapper

	{



		#region Declarations



		private string				_nunitExec = null;

		private ProcessStartInfo	_nunitinfo;

		private Process				_nunit;

		private bool				_onbuild;

		private XmlDocument			_results;

		private bool				_cusPath = false;

		public ArrayList				beginShow;
//		public ArrayList				endShow;


		#endregion



		#region CTor/~Ctor



		public CNUnitWrapper()

		{

	//		beginShow = new ArrayList();
	//		endShow = new ArrayList();

		}



		#endregion



		#region Properties


		public bool CusPath{
			get{return _cusPath;}
			set{_cusPath=value;}
		}

		public bool TestOnBuild

		{

			get

			{

				return _onbuild;

			}

			set

			{

				_onbuild = value;

			}

		}



		public string NUnitExec

		{

			get

			{

				return _nunitExec.ToString();

			}

			set

			{
				
				_nunitExec = value;

			}

		}



		public XmlDocument LastResults

		{

			get

			{

				if(_results != null && _results.OuterXml != "")

				{

					return _results;

				}

				else

				{

					return null;

				}

			}

		}



		#endregion



		#region Implementation



		public XmlDocument ReadInput(StreamReader input)

		{

			StringBuilder s = new StringBuilder();

			string _nunitline;
			
			beginShow = new ArrayList();


			while((_nunitline=input.ReadLine())!=null)

			{
				if(_nunitline.Trim() == ""){
					continue;
				}

				if(_nunitline.IndexOf("<?xml") != -1){
					break;
				}
				beginShow.Add(_nunitline);
			}

			s.Append(_nunitline);
			
			while((_nunitline=input.ReadLine())!=null){
				s.Append(_nunitline);
	/*			if(_nunitline.IndexOf("</test-results>") != -1){					
					break;
				}				
	*/
			}

	/*		while((_nunitline=input.ReadLine())!= null){
				if(_nunitline.Trim() == ""){
					continue;
				}
				endShow.Add(_nunitline);
			}

	*/		//System.Windows.Forms.MessageBox.Show(s.ToString());

			

			_results = new XmlDocument();

		

			if(s.ToString() != "")

			{

				_results.LoadXml(s.ToString());

				//System.Windows.Forms.MessageBox.Show(_results.OuterXml);

				return _results;

			}

			else

			{

				return null;

			}

		}

	


		public XmlDocument Test(string libpath)

		{

			StreamReader _nunitout;

			

			_nunitinfo = new ProcessStartInfo();

			_nunitinfo.FileName = this.NUnitExec;

			_nunitinfo.UseShellExecute = false;

			_nunitinfo.RedirectStandardOutput = true;

			_nunitinfo.CreateNoWindow = true;

			_nunitinfo.Arguments = "\"" + libpath + "\"" + " /nologo /xmlConsole";

			//System.Windows.Forms.MessageBox.Show(_nunitinfo.FileName + " " + _nunitinfo.Arguments);

			_nunit = Process.Start(_nunitinfo);

			_nunitout = _nunit.StandardOutput;



			XmlDocument results = ReadInput(_nunitout);

			_nunitout.Close();

			return results;





//			StringBuilder s = new StringBuilder();

//			string _nunitline;

//			while((_nunitline=_nunitout.ReadLine())!=null)

//			{

//				s.Append(_nunitline);

//			}

//			_nunitout.Close();

//

//			System.Windows.Forms.MessageBox.Show(s.ToString());

//			

//			_results = new XmlDocument();

//		

//			if(s.ToString() != "")

//			{

//				_results.LoadXml(s.ToString());

//				return _results;

//			}

//			else

//			{

//				return null;

//			}

		

//			return new XmlDocument();

			

		}



		public void SaveResults(string destFile)

		{

			if(_results != null && _results.OuterXml != "")

				_results.Save(destFile);

		}



		#endregion



	}

}

